//*                                                                     00030001
//*       S E N D M A I L                                               00040001
//*                                                                     00050001
//* PAY ATTENTION TO THE LINKEDIT OVERRIDES AT THE END OF THIS MEMBER
//*
//SENDMAIL EXEC DFHSACE4,NAME=SENDMAIL,TRNPARM='SP'
//SYSIN    DD  *                                                        00000130
           TITLE 'S E N D M A I L  TCPIP SOCKETS SENDMAIL'
*********************************************************************** 00000080
*                                                                     * 00000190
*     S E N D M A I L  THIS PROGRAM IS USED TO SEND EMAIL FROM CICS   * 00000190
*     USING THE CICS TCP/IP SOCKETS INTERFACE.                        * 00000190
*                                                                     * 00000190
*     COMMAREA FORMAT:                                                * 00000190
*          4 BYTES EMAIL SERVER LENGTH                                * 00000190
*         24 BYTES EMAIL SERVER NAME                                  * 00000190
*         40 BYTES RECIPIENT EMAIL ADDRESS                            * 00000190
*         40 BYTES SENDER EMAIL ADDRESS                               * 00000190
*         80 BYTES RECIPIENT NAME                                     * 00000190
*         80 BYTES SENDER NAME                                        * 00000190
*         80 BYTES SUBJECT                                            * 00000190
*         VARIABLE LENGTH MESSAGE BODY                                * 00000190
*                                                                     * 00000190
*    NOTE THAT THE COMMAREA IS FIXED FORMAT THROUGH THE SUBJECT LINE. * 00000190
*    THE MESSAGE BODY IS FREE FORM TEXT.  IF YOU WANT TO FORCE CRLF   * 00000190
*    YOU MUST EMBED X'0D25' WITHIN THE MESSAGE BODY AT THE CORRECT    * 00000190
*    PLACES.  THIS PROGRAM MAKES NO ASSUMPTION ABOUT THE FORMAT OF    *
*    THE MESSAGE BODY.                                                *
*                                                                     * 00000190
*    RETURN CODES:                                                    * 00000190
*         00  NORMAL                                                  * 00000190
*         F1  INVALID COMMAREA LENGTH                                 * 00000190
*         F2  INITAPI ERROR                                           * 00000190
*         F3  GETHOSTID ERROR                                         * 00000190
*         F4  OBTAIN ERROR                                            * 00000190
*         F5  CONNECT ERROR                                           * 00000190
*         F6  CLOSE ERROR                                             * 00000190
*         F7  READ ERROR                                              * 00000190
*         F8  WRITE ERROR                                             * 00000190
*         F9  SMTP RESPONSE ERROR                                     * 00000190
*         FF  NO COMMAREA OR OTHER ERRORS                             * 00000190
*                                                                     * 00000190
*    EXAMPLE:                                                         * 00000190
*                                                                     * 00000190
*     CA       DS   0D                                                * 00000190
*     CASERVLN DC   F'16'                                             * 00000190
*     CASERVER DC   CL24'YOUR.SMTP.SERVER'                            * 00000190
*     CARCPT   DC   CL40'DGRINSELL@STATE.MT.US'                       * 00000190
*     CAREPLY  DC   CL40'USERID@YOUR.SMTP.SERVER'                     * 00000190
*              ORG  CA                                                *
*     CARESP   DS   XL1                                               *
*              ORG                                                    * 00000190
*     CATO     DC   CL80'RECIPIENT NAME'                              * 00000190
*     CAFROM   DC   CL80'"CICS USER"<USERID@YOUR.SMTP.SERVER>'        * 00000190
*     CASUBJ   DC   CL80'MAIL FROM CICS'                              * 00000190
*     CABODY   DC   C'THIS IS THE FIRST LINE.',X'0D25'                * 00000190
*              DC   X'0D25'                                           * 00000190
*              DC   C'THIS IS THE NEXT PARAGRAPH.  '                  * 00000190
*              DC   C'THIS TEXT WILL BE APPENDED TO THE PREVIOUS '    * 00000190
*              DC   C'LINE.',X'0D25'                                  * 00000190
*     CALEN    DC   Y(*-CA)                                           *
*                                                                     * 00000190
*              EXEC CICS LINK PROGRAM('SENDMAIL')                     * 00000190
*                        COMMAREA(CA) LENGTH(CALEN)                   * 00000190
*              CLI  CARESP,X'FF'    Q-ERROR RETURN CODE               * 00000190
*              BE   SENDFAIL        BIF YES, ELSE CONTINUE            * 00000190
*                                                                     * 00000190
*********************************************************************** 00000200
         EJECT                                                        * 00000190
*********************************************************************** 00000200
*                                                                     * 00000190
*    REGISTER USAGE:                                                  * 00000190
*     R0                                                              * 00000190
*     R1                                                              * 00000190
*     R2   WORK                                                       * 00000190
*     R3   COMMAREA POINTER                                           * 00000190
*     R4   COMMAREA STOPPER                                           * 00000190
*     R5   BAL                                                        * 00000190
*     R6   OUTPUT BUFFER POINTER                                      * 00000190
*     R7                                                              * 00000190
*     R8                                                              * 00000190
*     R9                                                              * 00000190
*     R10                                                             * 00000190
*     R11  EIB BASE REGISTER                                          * 00000190
*     R12  CODE BASE REGISTER                                         * 00000190
*     R13  DATA BASE REGISTER                                         * 00000190
*     R14                                                             * 00000190
*     R15                                                             * 00000190
*                                                                     * 00000190
*********************************************************************** 00000200
         SPACE 2                                                        00000210
         EJECT                                                          00412300
*********************************************************************** 00000200
*                                                                     * 00000190
*        P R O G R A M     V A R I A B L E S                          * 00000190
*                                                                     * 00000190
*********************************************************************** 00000200
DFHEISTG DSECT                                                          00412400
         SPACE 1
DOUBLE            DS D          DOUBLE WORD ALIGNED WORK FIELD
RESP              DS H          RESPONSE FIELD FOR CICS COMMANDS
LENGTH            DS H          LENGTH FIELD FOR CICS COMMANDS
         SPACE 1
PARMLIST          DS 30A
         SPACE 1
ERROR_NUMBER      DS F          ERROR NUMBER                            00412800
                  ORG ERROR_NUMBER
HOST_ENT_PTR      DS A          HOST ENTRY POINTER                      00412800
RETURN_CODE       DS F          RETURN CODE                             00412800
CONNECT_NAME      DS 0F         NAME STRUCTURE FOR CONNECT
FAMILY            DS H          ADDRESSING FAMILY
PORT              DS H          PORT TO CONNECT ON (SMTP=25)
HOST_ADDRESS      DS F          HOST IP ADDRESS
                  DS XL8        RESERVED
MAX_SOCK_REQ      DS F          MAXIMUM SOCKETS REQUESTED
MAX_SOCK_RET      DS F          HIGHEST SOCKET RETURNED                 00412800
SOCKET_DESCRIPTOR DS H          SOCKET DESCRIPTOR
IDENT             DS 0CL16      IDENTITY ADDRESS SPACES
TCPIP_NAME        DS CL8        TCPIP ADDRESS SPACE NAME
CICS_JOB_NAME     DS CL8        CICS JOBNAME
SUBTASK_ID        DS XL8        UNIQUE SUBTASK IDENTIFIER
DUMP_CODE         DS CL4        DUMP CODE
NUM_BYTES         DS F          NUMBER OF BYTES IN I/O BUFFER
WRITE_BUFFER      DS CL256      BUFFER FOR WRITES
READ_BUFFER       DS 5CL100     BUFFER FOR READS
READ_BUFFER_END   EQU *
         EJECT                                                          00415000
***********************************************************************
*                                                                     *
*        C O M M A R E A     D S E C T                                *
*                                                                     *
***********************************************************************
         SPACE 1
COMMAREA DSECT
         USING *,R3
CASERVLN DS    F
CASERVER DS    CL24
CARCPT   DS    CL40
CAREPLY  DS    CL40
CATO     DS    CL80
CAFROM   DS    CL80
CASUBJ   DS    CL80
CABODY   EQU   *
         ORG   COMMAREA
CARESP   DS    XL1
         ORG
         EJECT                                                          00415000
SENDMAIL DFHEIENT CODEREG=(12),DATAREG=(13),EIBREG=(11)                 00420000
SENDMAIL AMODE 31
SENDMAIL RMODE ANY
         DFHREGS                                                           00430000
         EJECT                                                          00440000
START    DS    0H                 ** INITIALIZATION **                  00450000
* DO SOME BASIC COMMAREA VALIDATION...MUST BE AT LEAST 348 BYTES LONG
         L     R3,DFHEICAP        GET ADDRESS OF COMMAREA
         LTR   R3,R3              Q-IS COMMAREA AVAILABLE
         BZ    NOCOMM_ERROR       BIF NO
         USING COMMAREA,R3        SET ADDRESSABILITY
         CLC   EIBCALEN,=H'348'   Q-IS COMMAREA MINIMUM LENGTH
         BL    COMMLEN_ERROR      NO ISSUE DUMP
         LR    R4,R3              ADDRESS THE
         AH    R4,EIBCALEN            END OF THE COMMAREA
*
* FORMAT INITAPI CALL AND ISSUE
*
         MVC   MAX_SOCK_REQ,=H'50'
         MVC   TCPIP_NAME,=CL8'TCPIP' <== VERIFY THIS ON YOUR SYSTEM
         EXEC CICS INQUIRE SYSTEM JOBNAME(CICS_JOB_NAME)
         UNPK  SUBTASK_ID(7),EIBTASKN
         OI    SUBTASK_ID+6,X'F0'
         MVI   SUBTASK_ID+7,C'C'
         CALL EZASOKET,(INITAPI,MAX_SOCK_REQ,IDENT,SUBTASK_ID,         *
               MAX_SOCK_RET,ERROR_NUMBER,RETURN_CODE),                 *
               VL,MF=(E,PARMLIST)
         CLI   RETURN_CODE,X'FF'    ERROR RESPONSE ?
         BNE   OBTAIN               NO, CONTINUE
         CLC   ERROR_NUMBER,=F'10197'  INITAPI ALREADY BEEN ISSUED ?
         BNE   INITAPI_ERROR        NO, MUST BE SOME OTHER ERROR
*
* OBTAIN SOCKET
*
OBTAIN   DS    0H
         CALL EZASOKET,(SOCKET,AF,SOCTYPE,PROTO,                       *
               ERROR_NUMBER,RETURN_CODE),                              *
               VL,MF=(E,PARMLIST)
         CLI   RETURN_CODE,X'FF'    ERROR RESPONSE ?
         BE    OBTAIN_ERROR         YES, GET OUT OF HERE
         MVC   SOCKET_DESCRIPTOR,RETURN_CODE+2
*
* I CHOSE TO PASS THE NAME OF THE EMAIL SERVER IN THE COMMAREA.
* THERE IS NO REQUIREMENT TO DO SO.  ANY VALID SMTP SERVER WILL WORK.
* YOU COULD EASILY HARDCODE THE IP ADDRESS OF A SERVER IN HOST_ADDRESS
* OR YOU COULD ISSUE THE FOLLOWING GETHOSTID CALL TO RETRIEVE THE IP
* ADDRESS OF THE LOCAL MVS HOST.
*
* GET HOST IP ADDRESS
*
*        CALL EZASOKET,(GETHOSTID,HOST_ADDRESS),
*              VL,MF=(E,PARMLIST)
*
* GET IP ADDRESS OF SMTP SERVER
*
         CALL EZASOKET,(GETHOSTBYNAME,CASERVLN,CASERVER,               *
               ERROR_NUMBER,RETURN_CODE),                              *
               VL,MF=(E,PARMLIST)
         CLI   RETURN_CODE,X'FF'    ERROR RESPONSE ?
         BE    GETHOSTBYNAME_ERROR  YES, GET OUT OF HERE
         CLC   ERROR_NUMBER,=F'10214'  DNS LOOKUP ERROR ?
         BE    GETHOSTBYNAME_ERROR  YES, GET OUT OF HERE
         L     R1,ERROR_NUMBER      POINT TO THE HOSTENT STRUCTURE
         L     R1,16(R1)            POINT TO THE IP ADDRESS PTR
         L     R1,0(R1)             POINT TO THE IP ADDRESS
         MVC   HOST_ADDRESS,0(R1)   PICK UP THE IP ADDRESS
*
* CONNECT TO SMTP SERVER
*
         MVC   FAMILY,=H'2'         SET UP AF_INET FAMILY ID
         MVC   PORT,=H'25'          SET UP SMTP PORT
         CALL EZASOKET,(CONNECT,SOCKET_DESCRIPTOR,CONNECT_NAME,        *
               ERROR_NUMBER,RETURN_CODE),                              *
               VL,MF=(E,PARMLIST)
         CLI   RETURN_CODE,X'FF'    ERROR RESPONSE ?
         BE    CONNECT_ERROR        YES, GET OUT OF HERE
*
* MAKE INITIAL READ ON SOCKET AND ENSURE WE HAVE A 220 RESPONSE HERE
*
         BAL   R5,READ_SOCKET
         CLC   RESP_220,READ_BUFFER    EXPECTED RESPONSE ?
         BNE   RESP_ERROR              NO, ERROR
*
* SEND EMAIL MESSAGE
*
         LA    R6,WRITE_BUFFER
         MVC   WRITE_BUFFER(L'HELLO),HELLO
         MVC   WRITE_BUFFER+L'HELLO(L'CRLF),CRLF
         MVC   NUM_BYTES,=A(L'HELLO+2)
         BAL   R5,WRITE_SOCKET
         BAL   R5,READ_SOCKET
         CLC   RESP_250,READ_BUFFER    EXPECTED RESPONSE ?
         BNE   RESP_ERROR              NO, ERROR
         MVC   WRITE_BUFFER(L'MAILFROM),MAILFROM
         MVC   WRITE_BUFFER+L'MAILFROM(L'CAREPLY),CAREPLY
         MVI   WRITE_BUFFER+L'MAILFROM+L'CAREPLY,C'>'
         MVC   WRITE_BUFFER+L'MAILFROM+L'CAREPLY+1(L'CRLF),CRLF
         MVC   NUM_BYTES,=A(L'MAILFROM+L'CAREPLY+1+L'CRLF)
         BAL   R5,WRITE_SOCKET
         BAL   R5,READ_SOCKET
         CLC   RESP_250,READ_BUFFER    EXPECTED RESPONSE ?
         BNE   RESP_ERROR              NO, ERROR
         MVC   WRITE_BUFFER(L'RCPTTO),RCPTTO
         MVC   WRITE_BUFFER+L'RCPTTO(L'CARCPT),CARCPT
         MVI   WRITE_BUFFER+L'RCPTTO+L'CARCPT,C'>'
         MVC   WRITE_BUFFER+L'RCPTTO+L'CARCPT+1(L'CRLF),CRLF
         MVC   NUM_BYTES,=A(L'RCPTTO+L'CARCPT+1+L'CRLF)
         BAL   R5,WRITE_SOCKET
         BAL   R5,READ_SOCKET
         CLC   RESP_250,READ_BUFFER    EXPECTED RESPONSE ?
         BNE   RESP_ERROR              NO, ERROR
         MVC   WRITE_BUFFER(L'DATA),DATA
         MVC   WRITE_BUFFER+L'DATA(L'CRLF),CRLF
         MVC   NUM_BYTES,=A(L'DATA+L'CRLF)
         BAL   R5,WRITE_SOCKET
         BAL   R5,READ_SOCKET
         CLC   RESP_354,READ_BUFFER    EXPECTED RESPONSE ?
         BNE   RESP_ERROR              NO, ERROR
         MVC   WRITE_BUFFER(L'MSGTO),MSGTO
         MVC   WRITE_BUFFER+L'MSGTO(L'CATO),CATO
         MVC   WRITE_BUFFER+L'MSGTO+L'CATO(L'CRLF),CRLF
         MVC   NUM_BYTES,=A(L'MSGTO+L'CATO+L'CRLF)
         BAL   R5,WRITE_SOCKET
         MVC   WRITE_BUFFER(L'MSGFROM),MSGFROM
         MVC   WRITE_BUFFER+L'MSGFROM(L'CAFROM),CAFROM
         MVC   WRITE_BUFFER+L'MSGFROM+L'CAFROM(L'CRLF),CRLF
         MVC   NUM_BYTES,=A(L'MSGFROM+L'CAFROM+L'CRLF)
         BAL   R5,WRITE_SOCKET
         MVC   WRITE_BUFFER(L'MSGSUBJ),MSGSUBJ
         MVC   WRITE_BUFFER+L'MSGSUBJ(L'CASUBJ),CASUBJ
         MVC   WRITE_BUFFER+L'MSGSUBJ+L'CASUBJ(L'CRLF),CRLF
         MVC   WRITE_BUFFER+L'MSGSUBJ+L'CASUBJ+L'CRLF(L'CRLF),CRLF
         MVC   NUM_BYTES,=A(L'MSGSUBJ+L'CASUBJ+L'CRLF+L'CRLF)
         BAL   R5,WRITE_SOCKET
         LA    R6,CABODY             ADDRESS THE MESSAGE BODY
         SR    R4,R6                 CALCULATE LENGTH OF BODY
         ST    R4,NUM_BYTES
         BAL   R5,WRITE_SOCKET
         LA    R6,WRITE_BUFFER       POINT R6 BACK TO WRITE_BUFFER
         MVC   WRITE_BUFFER(L'CRLF),CRLF
         MVC   WRITE_BUFFER+L'CRLF(L'PERIOD),PERIOD
         MVC   WRITE_BUFFER+L'CRLF+L'PERIOD(L'CRLF),CRLF
         MVC   NUM_BYTES,=A(L'CRLF+L'PERIOD+L'CRLF)
         BAL   R5,WRITE_SOCKET
         BAL   R5,READ_SOCKET
         CLC   RESP_250,READ_BUFFER    EXPECTED RESPONSE ?
         BNE   RESP_ERROR              NO, ERROR
         MVC   WRITE_BUFFER(L'QUIT),QUIT
         MVC   WRITE_BUFFER+L'QUIT(L'CRLF),CRLF
         MVC   NUM_BYTES,=A(L'QUIT+L'CRLF)
         BAL   R5,WRITE_SOCKET
         BAL   R5,READ_SOCKET
         CLC   RESP_221,READ_BUFFER    EXPECTED RESPONSE ?
         BNE   RESP_ERROR              NO, ERROR
*
* CLOSE SOCKET
*
CLOSE_SOCKET DS 0H
         CALL EZASOKET,(CLOSE,SOCKET_DESCRIPTOR,                       *
               ERROR_NUMBER,RETURN_CODE),                              *
               VL,MF=(E,PARMLIST)
         CLI   RETURN_CODE,X'FF'    ERROR RESPONSE ?
         BE    CLOSE_ERROR          YES, GET OUT OF HERE
         MVI   CARESP,X'00'         SIGNIFY GOOD RETURN
*
* RETURN TO CALLER
*
RETURN   DS    0H
         EXEC CICS RETURN
         EJECT
*
* READ INPUT BUFFER UNTIL NOTHING REMAINS
*
READ_SOCKET    DS 0H
         MVC   NUM_BYTES,=A(READ_BUFFER_END-READ_BUFFER)
         CALL EZASOKET,(READ,SOCKET_DESCRIPTOR,                        *
               NUM_BYTES,READ_BUFFER,                                  *
               ERROR_NUMBER,RETURN_CODE),                              *
               VL,MF=(E,PARMLIST)
         CLI   RETURN_CODE,X'FF'    ERROR RESPONSE ?
         BE    READ_ERROR           YES, GET OUT OF HERE
         L     R2,RETURN_CODE       REMEMBER THE SIZE RETURNED
         CALL EZACIC05,(READ_BUFFER,RETURN_CODE),VL,MF=(E,PARMLIST)
         STH   R2,LENGTH            TELL CICS HOW MUCH TO WRITE
*
* THIS WRITEQ IS HERE FOR DEBUGGING PURPOSES SO I COULD SEE THE DATA
* SENT FOLLOWED BY THE RESPONSE FROM THE SMTP SERVER.  UNCOMMENT THIS
* IF YOU ARE NOT GETTING GOOD RESULTS TO SEE WHAT IS GOING ON.
*
*        EXEC CICS WRITEQ TS QUEUE('SOCKRESP') FROM(READ_BUFFER)       *
               LENGTH(LENGTH)
         SH    R2,=Y(2)              WAS THERE MORE THAN CRLF ?
         LA    R2,READ_BUFFER(R2)    ADDRESS END OF LINE
         CLC   CRLF,0(R2)            CRLF AT END OF LINE ?
         BNE   READ_SOCKET           NO, READ SOME MORE
         BR    R5
*
* WRITE OUTPUT BUFFER AND LOG RESPONSES
*
WRITE_SOCKET   DS 0H
         L     R2,NUM_BYTES         PICK UP THE OUTPUT SIZE
         STH   R2,LENGTH            TELL CICS HOW MUCH TO WRITE
*
* THIS WRITEQ IS HERE FOR DEBUGGING PURPOSES SO I COULD SEE THE DATA
* SENT FOLLOWED BY THE RESPONSE FROM THE SMTP SERVER.  UNCOMMENT THIS
* IF YOU ARE NOT GETTING GOOD RESULTS TO SEE WHAT IS GOING ON.
*
*        EXEC CICS WRITEQ TS QUEUE('SOCKRESP') FROM(0(R6))             *
               LENGTH(LENGTH)
         CALL EZACIC04,(0(R6),NUM_BYTES),VL,MF=(E,PARMLIST)
         CALL EZASOKET,(WRITE,SOCKET_DESCRIPTOR,                       *
               NUM_BYTES,0(R6),                                        *
               ERROR_NUMBER,RETURN_CODE),                              *
               VL,MF=(E,PARMLIST)
         CLI   RETURN_CODE,X'FF'    ERROR RESPONSE ?
         BE    WRITE_ERROR          YES, GET OUT OF HERE
         BR    R5
*
* GENERAL ERROR ROUTINE TO PRODUCE DUMP IN CASE OF FAILURES
*
NOCOMM_ERROR   DS 0H
         MVI   CARESP,X'FF'
         B     RETURN
COMMLEN_ERROR  DS 0H
         MVI   CARESP,X'F1'
         B     RETURN
INITAPI_ERROR  DS 0H
         MVI   CARESP,X'F2'
         MVC   DUMP_CODE,=CL4'INIT'
         BAL   R5,DUMP_IT
         B     RETURN
GETHOSTBYNAME_ERROR DS 0H
         MVI   CARESP,X'F3'
         MVC   DUMP_CODE,=CL4'GHST'
         BAL   R5,DUMP_IT
         B     RETURN
OBTAIN_ERROR   DS 0H
         MVI   CARESP,X'F4'
         MVC   DUMP_CODE,=CL4'OBTN'
         BAL   R5,DUMP_IT
         B     RETURN
CONNECT_ERROR  DS 0H
         MVI   CARESP,X'F5'
         MVC   DUMP_CODE,=CL4'CNCT'
         BAL   R5,DUMP_IT
         B     CLOSE_SOCKET
CLOSE_ERROR    DS 0H
         MVI   CARESP,X'F6'
         MVC   DUMP_CODE,=CL4'CLOS'
         BAL   R5,DUMP_IT
         B     CLOSE_SOCKET
READ_ERROR     DS 0H
         MVI   CARESP,X'F7'
         MVC   DUMP_CODE,=CL4'READ'
         BAL   R5,DUMP_IT
         B     CLOSE_SOCKET
WRITE_ERROR    DS 0H
         MVI   CARESP,X'F8'
         MVC   DUMP_CODE,=CL4'WRIT'
         BAL   R5,DUMP_IT
         B     CLOSE_SOCKET
RESP_ERROR     DS 0H
         MVI   CARESP,X'F9'
         MVC   DUMP_CODE,=CL4'RESP'
         BAL   R5,DUMP_IT
         B     CLOSE_SOCKET
DUMP_IT  DS 0H
         EXEC CICS DUMP TRANSACTION DUMPCODE(DUMP_CODE) RESP(RESP)
         BR    R5
         EJECT
***********************************************************************
*                                                                     *
*        P R O G R A M     C O N S T A N T S                          *
*                                                                     *
***********************************************************************
         SPACE 1
ACCEPT        DC CL16'ACCEPT'
BIND          DC CL16'BIND'
CLOSE         DC CL16'CLOSE'
CONNECT       DC CL16'CONNECT'
FCNTL         DC CL16'FCNTL'
GETCLIENTID   DC CL16'GETCLIENTID'
GETHOSTBYADDR DC CL16'GETHOSTBYADDR'
GETHOSTBYNAME DC CL16'GETHOSTBYNAME'
GETHOSTID     DC CL16'GETHOSTID'
GETHOSTNAME   DC CL16'GETHOSTNAME'
GETPEERNAME   DC CL16'GETPEERNAME'
GETSOCKNAME   DC CL16'GETSOCKNAME'
GETSOCKOPT    DC CL16'GETSOCKOPT'
GIVESOCKET    DC CL16'GIVESOCKET'
INITAPI       DC CL16'INITAPI'
IOCTL         DC CL16'IOCTL'
LISTEN        DC CL16'LISTEN'
READ          DC CL16'READ'
READV         DC CL16'READV'
RECV          DC CL16'RECV'
RECVFROM      DC CL16'RECVFROM'
RECVMSG       DC CL16'RECVMSG'
SELECT        DC CL16'SELECT'
SELECTEX      DC CL16'SELECTEX'
SEND          DC CL16'SEND'
SENDMSG       DC CL16'SENDMSG'
SENDTO        DC CL16'SENDTO'
SETSOCKOPT    DC CL16'SETSOCKOPT'
SHUTDOWN      DC CL16'SHUTDOWN'
SOCKET        DC CL16'SOCKET'
TAKESOCKET    DC CL16'TAKESOCKET'
TERMAPI       DC CL16'TERMAPI'
WRITE         DC CL16'WRITE'
WRITEV        DC CL16'WRITEV'
         SPACE 1
RESP_220 DC    C'220'
RESP_221 DC    C'221'
RESP_250 DC    C'250'
RESP_354 DC    C'354'
         SPACE 1
AF       DC    F'2'             ADDRESSING FAMILY = TCPIP               00412800
SOCTYPE  DC    F'1'             SOCKET TYPE = STREAM
PROTO    DC    F'0'             PROTOCOL = DEFAULT (TCP)
CRLF     DC    XL2'0D25'        CARRIAGE RETURN / LINE FEED
         SPACE 1
HELLO    DC    C'HELO HLNCTR'
MAILFROM DC    C'MAIL FROM: <'
RCPTTO   DC    C'RCPT TO: <'
DATA     DC    C'DATA'
MSGTO    DC    C'TO: '
MSGFROM  DC    C'FROM: '
MSGSUBJ  DC    C'SUBJECT: '
PERIOD   DC    C'.'
QUIT     DC    C'QUIT'
         SPACE 1
         END                                                            07880000
//LKED.SYSLIB DD
// DD DISP=SHR,DSN=SYS1.TCPIP.SEZATCP
//LKED.SYSIN DD *
  INCLUDE SYSLIB(EZACICAL)
