//*                                                                     00030001
//*       S E N D M A I L                                               00040001
//*                                                                     00050001
//SENDMAIL EXEC DFHSACE4,NAME=SENDMAIL
//SYSIN    DD  *                                                        00000130
           TITLE 'S E N D M A I L  TCPSMTP MAIL INTERFACE'
*********************************************************************** 00000080
*                                                                     * 00000190
*     S E N D M A I L  THIS PROGRAM IS USED TO SEND EMAIL FROM CICS   * 00000190
*     USING THE CICS SPOOL INTERFACE.                                 * 00000190
*                                                                     * 00000190
*     COMMAREA FORMAT:                                                * 00000190
*         40 BYTES RECIPIENT EMAIL ADDRESS                            * 00000190
*         40 BYTES SENDER EMAIL ADDRESS                               * 00000190
*         80 BYTES TO:                                                * 00000190
*         80 BYTES FROM:                                              * 00000190
*         80 BYTES SUBJECT:                                           * 00000190
*         80 BYTES MESSAGE TEXT                                       * 00000190
*            ....                                                     * 00000190
*         80 BYTES END OF MESSAGE LINES                               * 00000190
*                                                                     * 00000190
*    NOTE THAT THE COMMAREA MUST BE A MULTIPLE OF 80 CHARACTERS       * 00000190
*    AND BE A MINIMUM OF 5*80 OR 400 BYTES LONG AND A MAXIMUM OF      * 00000190
*    32K (CICS COMMAREA LIMIT).                                       * 00000190
*                                                                     * 00000190
*    RETURN CODES:                                                    * 00000190
*         FF  ERROR                                                   * 00000190
*                                                                     * 00000190
*    EXAMPLE:                                                         * 00000190
*                                                                     * 00000190
*     CA       DS   0D                                                * 00000190
*     CARCPT   DC   CL40'DGRINSELL@STATE.MT.US'                       * 00000190
*     CAFROM   DC   CL40'CZ0055@HLNCTR.STATE.MT.US'                   * 00000190
*              ORG  CA                                                *
*     CARESP   DC   XL1'00'                                           *
*              ORG                                                    * 00000190
*     CAMSG1   DC   CL80'TO:  DONALD GRINSELL'                        * 00000190
*     CAMSG2   DC   CL80'FROM: "CZ0055 ON CICS"<DGRINSELL@STATE.MT.US>* 00000190
*     CAMSG3   DC   CL80'SUBJECT: MAIL FROM CICS'                     * 00000190
*     CAMSG4   DC   CL80' '                                           * 00000190
*     CAMSG5   DC   CL80'THIS IS MY MESSAGE'                          * 00000190
*     CALEN    DC   Y(*-CA)                                           *
*                                                                     * 00000190
*              EXEC CICS LINK PROGRAM('SENDMAIL')                     * 00000190
*                        COMMAREA(CA) LENGTH(CALEN)                   * 00000190
*              CLI  CARESP,X'FF'    Q-ERROR RETURN CODE               * 00000190
*              BE   SENDFAIL        BIF YES, ELSE CONTINUE            * 00000190
*                                                                     * 00000190
*********************************************************************** 00000200
         EJECT                                                        * 00000190
*********************************************************************** 00000200
*                                                                     * 00000190
*    REGISTER USAGE:                                                  * 00000190
*     R0                                                              * 00000190
*     R1                                                              * 00000190
*     R2                                                              * 00000190
*     R3   COMMAREA POINTER                                           * 00000190
*     R4   COMMAREA STOPPER                                           * 00000190
*     R5   BAL                                                        * 00000190
*     R6                                                              * 00000190
*     R7                                                              * 00000190
*     R8                                                              * 00000190
*     R9                                                              * 00000190
*     R10                                                             * 00000190
*     R11  EIB BASE REGISTER                                          * 00000190
*     R12  CODE BASE REGISTER                                         * 00000190
*     R13  DATA BASE REGISTER                                         * 00000190
*     R14                                                             * 00000190
*     R15                                                             * 00000190
*                                                                     * 00000190
*********************************************************************** 00000200
         SPACE 2                                                        00000210
         EJECT                                                          00412300
*********************************************************************** 00000200
*                                                                     * 00000190
*        P R O G R A M     V A R I A B L E S                          * 00000190
*                                                                     * 00000190
*********************************************************************** 00000200
DFHEISTG DSECT                                                          00412400
         SPACE 1
RESP     DS    F                                                        00412800
TOKEN    DS    CL8
WORKLINE DS    CL80
         SPACE 1
*********************************************************************** 00000200
*                                                                     * 00000190
*        C O M M A R E A     D S E C T                                * 00000190
*                                                                     * 00000190
*********************************************************************** 00000200
         SPACE 1
COMMAREA DSECT                                                          00414500
CARCPT   DS    CL40
CAFROM   DS    CL40
         ORG   COMMAREA
CAMSG    DS    CL80
CANEXT   EQU   *
         ORG   COMMAREA
CARESP   DS    XL1
         ORG
         SPACE 3
*********************************************************************** 00000200
         EJECT                                                          00415000
SENDMAIL DFHEIENT CODEREG=(12),DATAREG=(13),EIBREG=(11)                 00420000
SENDMAIL AMODE 31
SENDMAIL RMODE ANY
         DFHREGS                                                           00430000
         EJECT                                                          00440000
         SPACE 2
START    DS    0H                 ** INITIALIZATION **                  00450000
         L     R3,DFHEICAP        GET ADDRESS OF COMMAREA               00600000
         LTR   R3,R3              Q-IS COMMAREA AVAILABLE               00620000
         BZ    RETURN8            BIF NO                                00630000
         USING COMMAREA,R3        SET ADDRESSABILITY                    00631000
         CLC   EIBCALEN,=H'400'   Q-IS COMMAREA OF PROPER LENGTH        00640000
         BL    RETURN8            YES                                   00650000
         LR    R4,R3              ADDRESS THE
         AH    R4,EIBCALEN            END OF THE COMMAREA
* BUILD EMAIL MESSAGES
         EXEC CICS SPOOLOPEN OUTPUT TOKEN(TOKEN) USERID(TCPSMTP)       *
               NODE(NODE) CLASS(CLASSB) NOCC PUNCH RESP(RESP)
         CLC   RESP,DFHRESP(NORMAL)
         BNE   RETURN8
         MVC   WORKLINE,HELLO
         BAL   R5,WRITE
         MVC   WORKLINE,MAILFROM
         MVC   WORKLINE+12(L'CAFROM),CAFROM
         BAL   R5,WRITE
         MVC   WORKLINE,RCPTTO
         MVC   WORKLINE+10(L'CARCPT),CARCPT
         BAL   R5,WRITE
         MVC   WORKLINE,DATA
         BAL   R5,WRITE
         LA    R3,CANEXT
SENDLOOP DS    0H
         MVC   WORKLINE,CAMSG
         BAL   R5,WRITE
         LA    R3,CANEXT
         CR    R3,R4
         BL    SENDLOOP
         EXEC CICS SPOOLCLOSE TOKEN(TOKEN) KEEP RESP(RESP)
         CLC   RESP,DFHRESP(NORMAL)
         BE    RETURN
RETURN8  DS    0H                 ** INVALID COMMAREA LENGTH **
         MVI   CARESP,X'FF'       SET RC=ERROR
RETURN   DS    0H
         EXEC CICS RETURN                                               00980000
WRITE    DS    0H
         EXEC CICS SPOOLWRITE TOKEN(TOKEN) FROM(WORKLINE) RESP(RESP)
         CLC   RESP,DFHRESP(NORMAL)
         BNE   RETURN8
         BR    R5
         SPACE 2                                                        07870000
***********************************************************************
         EJECT
***********************************************************************
*                                                                     *
*        P R O G R A M     C O N S T A N T S                          *
*                                                                     *
***********************************************************************
         SPACE 1
TCPSMTP  DC    CL8'TCPSMTP'
NODE     DC    CL8'HLNCTR'
CLASSB   DC    CL1'B'
HELLO    DC    CL80'HELO HLNCTR'
MAILFROM DC    CL80'MAIL FROM: <123456789012345678901234567890123456789*
               0>'
RCPTTO   DC    CL80'RCPT TO: <1234567890123456789012345678901234567890>*
               '
DATA     DC    CL80'DATA'
         SPACE 3
***********************************************************************
         SPACE 1
         END                                                            07880000
